# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ResourcesManagement::Mgmt::V2018_01_01_preview
  module Models
    #
    # The child information of a management group used during creation.
    #
    class CreateManagementGroupChildInfo

      include MsRestAzure

      # @return [Enum] The type of child resource. The fully qualified resource
      # type which includes provider namespace (e.g.
      # /providers/Microsoft.Management/managementGroups). Possible values
      # include: '/providers/Microsoft.Management/managementGroups',
      # '/subscriptions'
      attr_accessor :type

      # @return [String] The fully qualified ID for the child resource
      # (management group or subscription).  For example,
      # /providers/Microsoft.Management/managementGroups/0000000-0000-0000-0000-000000000000
      attr_accessor :id

      # @return [String] The name of the child entity.
      attr_accessor :name

      # @return [String] The friendly name of the child resource.
      attr_accessor :display_name

      # @return [Array<String>] The roles definitions associated with the
      # management group.
      attr_accessor :roles

      # @return [Array<CreateManagementGroupChildInfo>] The list of children.
      attr_accessor :children


      #
      # Mapper for CreateManagementGroupChildInfo class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'CreateManagementGroupChildInfo',
          type: {
            name: 'Composite',
            class_name: 'CreateManagementGroupChildInfo',
            model_properties: {
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              display_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'displayName',
                type: {
                  name: 'String'
                }
              },
              roles: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'roles',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              children: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'children',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'CreateManagementGroupChildInfoElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'CreateManagementGroupChildInfo'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
